<template>
  <div>
    <v-card class="pl-6 pr-6 pb-5 pt-2">
      <v-card-title class="pb-0">
        <h1>
          <b v-if="detalleCompra">{{$t('editarDetalle')}}</b>
          <b v-else>{{$t('nuevoDetalle')}}</b>
        </h1>
      </v-card-title>
      <v-form v-model="valid" ref="detalleCompraFrom" class="pb-4 pt-4">
        <v-row>
          <v-col cols="12" lg="4" md="4" sm="12" class="mt-3">
            <v-text-field
              v-model="form.cantidad"
              type="numeric"
              :rules="rules.isRequired"
              dense
              :label="$t('cantidad')"
            />
          </v-col>
          <v-col cols="12" lg="4" md="4" sm="12" class="mt-3">
            <v-text-field
              v-model="form.precio"
              :rules="rules.isRequired"
              dense
              :label="$t('precio')"
            />
          </v-col>
          <v-col cols="12" lg="4" md="4" sm="12">
            <h3 class="pt-4">
              <span class="success--text">{{ $t('total') }} {{ ' : ' }} {{ total }}</span>
            </h3>
          </v-col>
        </v-row>
      </v-form>
      <v-card-actions>
        <v-row>
          <v-btn
            color="accent"
            rounded
            @click="guardarDetalleCompra"
          >
            {{$t('guardar')}}
          </v-btn>
          <v-btn text color="error" rounded @click="cancelarGuardar">
            {{$t('cancelar')}}
          </v-btn>
          <br/>
        </v-row>
      </v-card-actions>
    </v-card>
  </div>
</template>

<script>
import DetalleCompraServicio from '@/store/services/DetalleCompraServicio'
export default {
  name:'DetalleComprasForm',
  components: {
  },
  props: {
    detalleCompra: {
      type: Object,
      required: false,
      default: null
    }
  },
  data () {
    return {
      valid: false,
      form: {
        id: null,
        cantidad: 0,
        precio: 0,
        precio_total: 0
      },
      rules: {
        isRequired: [value => !!value || this.$t('errorAlCargar')],
      },
      isLoading: false,
    }
  },
  methods: {
    async guardarDetalleCompra() {
      try {
        if (this.$refs.detalleCompraFrom.validate()) {
          var response = ''
          this.form.precio_total = this.form.cantidad * this.form.precio
          if (!this.form.id || this.form.id === '') {
            let dataForm = new FormData()
            for (let key in this.form) {
              dataForm.append(key, this.form[key])
            }
            response = await DetalleCompraServicio.create(dataForm)
          } else {
            response = await DetalleCompraServicio.update(this.form.id, this.form)
          }
          this.resetData()
          this.$emit('onDetalleCompraGuardada', response.data)
        }
      } catch (e) {console.log(e)
        if (e.response.status > 300) {
          console.log('error compra')
        }
      }
    },
    cancelarGuardar() {
      this.resetData()
      this.$emit('onCancelarGuardar',  false);
    },
    setData() {
      if (this.detalleCompra) {
        this.form.id = this.detalleCompra.id
        this.form.cantidad = this.detalleCompra.cantidad
        this.form.precio = this.detalleCompra.precio
      }
    },
    resetData() {
      this.form.id = null
      this.form.cantidad = 0
      this.form.precio = 0
      this.form.precio_total = 0
    }
  },
  computed: {
    total() {
      return this.form.cantidad * this.form.precio
    }
  },
  watch: {
    detalleCompra: {
      immediate: true,
      handler() {
        this.setData()
      }
    }
  },
  created() {
    this.setData()
  }
}
</script>

<style>

</style>
